diff --git a/src/V3DfgDecomposition.cpp b/src/V3DfgDecomposition.cpp
index 6f2aa82fb2b..c73d1b9799c 100644
--- a/src/V3DfgDecomposition.cpp
+++ b/src/V3DfgDecomposition.cpp
@@ -65,8 +65,14 @@ class SplitIntoComponents final {
                 item.user<size_t>() = m_componentCounter;
 
                 // Enqueue all sources and sinks of this vertex.
-                item.forEachSource([&](DfgVertex& src) { queue.push_back(&src); });
-                item.forEachSink([&](DfgVertex& dst) { queue.push_back(&dst); });
+                item.foreachSource([&](DfgVertex& src) {
+                    queue.push_back(&src);
+                    return false;
+                });
+                item.foreachSink([&](DfgVertex& dst) {
+                    queue.push_back(&dst);
+                    return false;
+                });
             } while (!queue.empty());
 
             // Done with this component
@@ -118,21 +124,6 @@ std::vector<std::unique_ptr<DfgGraph>> DfgGraph::splitIntoComponents(const std::
 }
 
 class ExtractCyclicComponents final {
-    // TYPES
-    // We reuse the DfgVertex::user state set by V3DfgPasses::colorStronglyConnectedComponents.
-    // We sneak an extra flag into the MSB to indicate the vertex was merged already.
-    class VertexState final {
-        uint64_t& m_userr;
-
-    public:
-        explicit VertexState(DfgVertex& vtx)
-            : m_userr{vtx.getUser<uint64_t>()} {}
-        bool merged() const { return m_userr >> 63; }
-        void setMerged() { m_userr |= 1ULL << 63; }
-        uint64_t component() const { return m_userr & ~(1ULL << 63); }
-        void component(uint64_t value) { m_userr = (m_userr & (1ULL << 63)) | value; }
-    };
-
     // STATE
     DfgGraph& m_dfg;  // The input graph
     const std::string m_prefix;  // Component name prefix
@@ -143,45 +134,86 @@ class ExtractCyclicComponents final {
     std::unordered_map<const DfgVertexVar*, std::unordered_map<uint64_t, DfgVertexVar*>> m_clones;
 
     // METHODS
-    void visitMergeSCCs(DfgVertex& vtx, uint64_t targetComponent) {
-        VertexState vtxState{vtx};
-
-        // Move on if already visited
-        if (vtxState.merged()) return;
-
-        // Visiting vertex
-        vtxState.setMerged();
-
-        // Assign vertex to the target component
-        vtxState.component(targetComponent);
+    void addVertexAndExpandSiblings(DfgVertex& vtx, uint64_t component) {
+        // Do not go past a variable, we will partition the graph there
+        if (vtx.is<DfgVertexVar>()) return;
+        // Don't need to recurse if the vertex is already in the same component,
+        // it was either marked through an earlier traversal, in which case it
+        // was processed recursively, or it will be processed later.
+        if (vtx.getUser<uint64_t>() == component) return;
+        // Because all cycles are through a variable, we can't reach another SCC.
+        UASSERT_OBJ(!vtx.getUser<uint64_t>(), &vtx, "Cycle without variable involvement");
+        // Put this vertex in the component, and continue recursively
+        vtx.setUser<uint64_t>(component);
+        expandSiblings(vtx, component);
+    }
 
-        // Visit all neighbors. We stop at variable boundaries,
-        // which is where we will split the graphs
-        vtx.forEachSource([this, targetComponent](DfgVertex& other) {
-            if (other.is<DfgVertexVar>()) return;
-            visitMergeSCCs(other, targetComponent);
+    void expandSiblings(DfgVertex& vtx, uint64_t component) {
+        UASSERT_OBJ(vtx.getUser<uint64_t>() == component, &vtx, "Traversal didn't stop");
+        vtx.foreachSink([&](DfgVertex& v) {
+            addVertexAndExpandSiblings(v, component);
+            return false;
         });
-        vtx.forEachSink([this, targetComponent](DfgVertex& other) {
-            if (other.is<DfgVertexVar>()) return;
-            visitMergeSCCs(other, targetComponent);
+        vtx.foreachSource([&](DfgVertex& v) {
+            addVertexAndExpandSiblings(v, component);
+            return false;
         });
     }
 
-    void mergeSCCs() {
-        // Ensure that component boundaries are always at variables, by merging SCCs. Merging stops
-        // at variable boundaries, so we don't need to iterate variables. Constants are reachable
-        // from their sinks, or are unused, so we don't need to iterate them either.
+    void expandComponents() {
+        // Important fact that we will assume below: There are no path between
+        // any two SCCs that do not go through a variable before reaching the
+        // destination SCC. That is, to get from one SCC to another, you must
+        // go through a variable that is not part of the destination SCC. This
+        // holds because no operation vertex can have multiple sinks at this
+        // point (constants have no inputs, so they are not in an SCC).
+        if (m_doExpensiveChecks) {
+            for (DfgVertex& vtx : m_dfg.opVertices()) {
+                UASSERT_OBJ(!vtx.hasMultipleSinks(), &vtx, "Operation has multiple sinks");
+            }
+        }
+
+        // We will break the graph at variable boundaries, but we want both
+        // 'srcp', and 'defaultp' to be in the same component, so for each
+        // cyclic variable, put both its 'srcp' and 'defaultp' into the same
+        // component if they are not variables themselves. The assertions below
+        // must hold because of the assumption above.
+        for (DfgVertexVar& vtx : m_dfg.varVertices()) {
+            const uint64_t varComponent = vtx.getUser<uint64_t>();
+            if (!varComponent) continue;
+            if (DfgVertex* const srcp = vtx.srcp()) {
+                if (!srcp->is<DfgVertexVar>()) {
+                    const uint64_t srcComponent = srcp->getUser<uint64_t>();
+                    UASSERT_OBJ(!srcComponent || srcComponent == varComponent, srcp,
+                                "Cycle through 'srcp' that does not go through variable.");
+                    srcp->setUser<uint64_t>(varComponent);
+                }
+            }
+            if (DfgVertex* const defp = vtx.defaultp()) {
+                if (!defp->is<DfgVertexVar>()) {
+                    const uint64_t defComponent = defp->getUser<uint64_t>();
+                    UASSERT_OBJ(!defComponent || defComponent == varComponent, defp,
+                                "Cycle through 'defaultp' that does not go through variable");
+                    defp->setUser<uint64_t>(varComponent);
+                }
+            }
+        }
+
+        // To ensure all component boundaries are at variables, expand
+        // components to include all reachable non-variable vertices. Constants
+        // are reachable from their sinks, so only need to process op vertices.
+        // We do this by staring a DFS from each vertex that is part of an
+        // component and add all reachable non-variable vertices to the same.
         for (DfgVertex& vtx : m_dfg.opVertices()) {
-            // Start DFS from each vertex that is in a non-trivial SCC, and merge everything
-            // that is reachable from it into this component.
-            if (const uint64_t target = VertexState{vtx}.component()) visitMergeSCCs(vtx, target);
+            if (const uint64_t targetComponent = vtx.getUser<uint64_t>()) {
+                expandSiblings(vtx, targetComponent);
+            }
         }
     }
 
     // Retrieve clone of vertex in the given component
-    DfgVertexVar& getClone(DfgVertexVar& vtx, uint64_t component) {
-        UASSERT_OBJ(VertexState{vtx}.component() != component, &vtx,
-                    "Vertex is in that component");
+    DfgVertexVar* getClone(DfgVertexVar& vtx, uint64_t component) {
+        UASSERT_OBJ(vtx.getUser<uint64_t>() != component, &vtx, "Vertex is in that component");
         DfgVertexVar*& clonep = m_clones[&vtx][component];
         if (!clonep) {
             if (DfgVarPacked* const pVtxp = vtx.cast<DfgVarPacked>()) {
@@ -201,40 +233,52 @@ class ExtractCyclicComponents final {
             clonep->setUser<uint64_t>(component);
             clonep->tmpForp(vtx.tmpForp());
         }
-        return *clonep;
+        return clonep;
     }
 
     // Fix edges that cross components
     void fixEdges(DfgVertexVar& vtx) {
-        const uint64_t component = VertexState{vtx}.component();
-
-        // Fix up sources in a different component
-        vtx.forEachSourceEdge([&](DfgEdge& edge, size_t) {
-            DfgVertex* const srcp = edge.sourcep();
-            if (!srcp) return;
-            const uint64_t sourceComponent = VertexState{*srcp}.component();
-            // Same component is OK
-            if (sourceComponent == component) return;
-            // Relink the source to write the clone
-            edge.unlinkSource();
-            getClone(vtx, sourceComponent).srcp(srcp);
+        const uint64_t component = vtx.getUser<uint64_t>();
+
+        // Fix up srcp and dstp (they must be the same component, or variable)
+        if (DfgVertex* const sp = vtx.srcp()) {
+            const uint64_t srcComponent = sp->getUser<uint64_t>();
+            if (srcComponent != component) {
+                UASSERT_OBJ(sp->is<DfgVertexVar>(), &vtx, "'srcp' in different component");
+                getClone(vtx, srcComponent)->srcp(sp);
+                vtx.srcp(nullptr);
+            }
+        }
+        if (DfgVertex* const dp = vtx.defaultp()) {
+            const uint64_t defaultComponent = dp->getUser<uint64_t>();
+            if (defaultComponent != component) {
+                UASSERT_OBJ(dp->is<DfgVertexVar>(), &vtx, "'defaultp' in different component");
+                getClone(vtx, defaultComponent)->defaultp(dp);
+                vtx.defaultp(nullptr);
+            }
+        }
+        // Fix up sinks in a different component to read the clone
+        std::vector<DfgVertex*> sinkps;
+        vtx.foreachSink([&](DfgVertex& sink) {
+            sinkps.emplace_back(&sink);
+            return false;
         });
-
-        // Fix up sinks in a different component
-        vtx.forEachSinkEdge([&](DfgEdge& edge) {
-            const uint64_t sinkComponent = VertexState{*edge.sinkp()}.component();
+        for (DfgVertex* const sinkp : sinkps) {
+            const uint64_t sinkComponent = sinkp->getUser<uint64_t>();
             // Same component is OK
-            if (sinkComponent == component) return;
-            // Relink the sink to read the clone
-            edge.relinkSource(&getClone(vtx, sinkComponent));
-        });
+            if (sinkComponent == component) continue;
+            DfgVertex* const clonep = getClone(vtx, sinkComponent);
+            for (size_t i = 0; i < sinkp->nInputs(); ++i) {
+                if (sinkp->inputp(i) == &vtx) sinkp->inputp(i, clonep);
+            }
+        }
     }
 
     template <typename Vertex>
     void moveVertices(DfgVertex::List<Vertex>& list) {
         for (DfgVertex* const vtxp : list.unlinkable()) {
             DfgVertex& vtx = *vtxp;
-            if (const uint64_t component = VertexState{vtx}.component()) {
+            if (const uint64_t component = vtx.getUser<uint64_t>()) {
                 m_dfg.removeVertex(vtx);
                 m_components[component - 1]->addVertex(vtx);
             }
@@ -242,20 +286,15 @@ class ExtractCyclicComponents final {
     }
 
     void checkEdges(DfgGraph& dfg) const {
-        // Check that:
-        // - Edges only cross components at variable boundaries
-        // - Variable vertex sources are all connected.
+        // Check that edges only cross components at variable boundaries
         dfg.forEachVertex([&](DfgVertex& vtx) {
-            const uint64_t component = VertexState{vtx}.component();
-            vtx.forEachSource([&](DfgVertex& src) {
-                if (src.is<DfgVertexVar>()) return;  // OK to cross at variables
-                UASSERT_OBJ(component == VertexState{src}.component(), &vtx,
-                            "Edge crossing components without variable involvement");
-            });
-            vtx.forEachSink([&](DfgVertex& snk) {
-                if (snk.is<DfgVertexVar>()) return;  // OK to cross at variables
-                UASSERT_OBJ(component == VertexState{snk}.component(), &vtx,
+            if (vtx.is<DfgVarPacked>()) return;
+            const uint64_t component = vtx.getUser<uint64_t>();
+            vtx.foreachSink([&](DfgVertex& snk) {
+                if (snk.is<DfgVertexVar>()) return false;  // OK to cross at variables
+                UASSERT_OBJ(component == snk.getUser<uint64_t>(), &vtx,
                             "Edge crossing components without variable involvement");
+                return false;
             });
         });
     }
@@ -267,11 +306,13 @@ class ExtractCyclicComponents final {
 
         // Check that each edge connects to a vertex that is within the same graph
         dfg.forEachVertex([&](const DfgVertex& vtx) {
-            vtx.forEachSource([&](const DfgVertex& src) {
+            vtx.foreachSource([&](const DfgVertex& src) {
                 UASSERT_OBJ(vertices.count(&src), &vtx, "Source vertex not in graph");
+                return false;
             });
-            vtx.forEachSink([&](const DfgVertex& snk) {
+            vtx.foreachSink([&](const DfgVertex& snk) {
                 UASSERT_OBJ(vertices.count(&snk), &snk, "Sink vertex not in graph");
+                return false;
             });
         });
     }
@@ -319,14 +360,13 @@ class ExtractCyclicComponents final {
         : m_dfg{dfg}
         , m_prefix{dfg.name() + (label.empty() ? "" : "-") + label + "-component-"} {
         // DfgVertex::user<uint64_t> is set to the SCC number by colorStronglyConnectedComponents,
-        // Then we use VertexState to handle the MSB as an extra flag.
         const auto userDataInUse = dfg.userDataInUse();
         // Find all the non-trivial SCCs (and trivial cycles) in the graph
         const uint32_t numNonTrivialSCCs = V3DfgPasses::colorStronglyConnectedComponents(dfg);
         // If the graph was acyclic (which should be the common case), then we are done.
         if (!numNonTrivialSCCs) return;
-        // Ensure that component boundaries are always at variables, by merging SCCs
-        mergeSCCs();
+        // Ensure that component boundaries are always at variables, by expanding SCCs
+        expandComponents();
         // Extract the components
         extractComponents(numNonTrivialSCCs);
     }
diff --git a/src/V3DfgDfgToAst.cpp b/src/V3DfgDfgToAst.cpp
index 3894534b6f0..63d1f3c1483 100644
--- a/src/V3DfgDfgToAst.cpp
+++ b/src/V3DfgDfgToAst.cpp
@@ -92,32 +92,23 @@ class DfgToAstVisitor final : DfgVisitor {
     const VNUser2InUse m_user2InUse;
 
     // TYPES
-    using VariableType = std::conditional_t<T_Scoped, AstVarScope, AstVar>;
-    struct Assignment final {
-        FileLine* m_flp;
-        AstNodeExpr* m_lhsp;
-        AstNodeExpr* m_rhsp;
-        Assignment() = delete;
-        Assignment(FileLine* flp, AstNodeExpr* lhsp, AstNodeExpr* m_rhsp)
-            : m_flp{flp}
-            , m_lhsp{lhsp}
-            , m_rhsp{m_rhsp} {}
-    };
+    using Variable = std::conditional_t<T_Scoped, AstVarScope, AstVar>;
+    using Container = std::conditional_t<T_Scoped, AstActive, AstNodeModule>;
 
     // STATE
     AstModule* const m_modp;  // The parent/result module - This is nullptr when T_Scoped
     V3DfgDfgToAstContext& m_ctx;  // The context for stats
     AstNodeExpr* m_resultp = nullptr;  // The result node of the current traversal
-    std::vector<Assignment> m_assignments;  // Assignments to currently rendered variable
-    std::vector<Assignment> m_defaults;  // Default assignments to currently rendered variable
+    AstAlways* m_alwaysp = nullptr;  // Process to add assignments to, if have a default driver
+    Container* m_containerp = nullptr;  // The AstNodeModule or AstActive to insert assigns into
 
     // METHODS
 
-    static VariableType* getNode(const DfgVertexVar* vtxp) {
+    static Variable* getNode(const DfgVertexVar* vtxp) {
         if VL_CONSTEXPR_CXX17 (T_Scoped) {
-            return reinterpret_cast<VariableType*>(vtxp->varScopep());
+            return reinterpret_cast<Variable*>(vtxp->varScopep());
         } else {
-            return reinterpret_cast<VariableType*>(vtxp->varp());
+            return reinterpret_cast<Variable*>(vtxp->varp());
         }
     }
 
@@ -158,49 +149,57 @@ class DfgToAstVisitor final : DfgVisitor {
         return resultp;
     }
 
-    void convertDriver(std::vector<Assignment>& assignments, FileLine* flp, AstNodeExpr* lhsp,
-                       DfgVertex* driverp) {
+    void createAssignment(FileLine* flp, AstNodeExpr* lhsp, DfgVertex* driverp) {
+        // Keep track of statisticss
+        ++m_ctx.m_resultEquations;
+        // Render the driver
+        AstNodeExpr* const rhsp = convertDfgVertexToAstNodeExpr(driverp);
+        // Update LHS locations to reflect the location of the original driver
+        lhsp->foreach([&](AstNode* nodep) { nodep->fileline(flp); });
+
+        // If using a process, add Assign there
+        if (m_alwaysp) {
+            m_alwaysp->addStmtsp(new AstAssign{flp, lhsp, rhsp});
+            return;
+        }
+
+        // Otherwise create an AssignW
+        m_containerp->addStmtsp(new AstAssignW{flp, lhsp, rhsp});
+    }
+
+    void convertDriver(FileLine* flp, AstNodeExpr* lhsp, DfgVertex* driverp) {
         if (DfgSplicePacked* const sPackedp = driverp->cast<DfgSplicePacked>()) {
-            // Render defaults first
-            if (DfgVertex* const defaultp = sPackedp->defaultp()) {
-                convertDriver(m_defaults, flp, lhsp, defaultp);
-            }
-            // Render partial assignments of packed value
-            sPackedp->forEachSourceEdge([&](const DfgEdge& edge, size_t i) {
-                DfgVertex* const srcp = edge.sourcep();
-                if (srcp == sPackedp->defaultp()) return;
+            // Partial assignment of packed value
+            sPackedp->foreachDriver([&](DfgVertex& src, uint32_t lo, FileLine* dflp) {
                 // Create Sel
-                FileLine* const dflp = sPackedp->driverFileLine(i);
-                AstConst* const lsbp = new AstConst{dflp, sPackedp->driverLo(i)};
-                const int width = static_cast<int>(srcp->width());
+                AstConst* const lsbp = new AstConst{dflp, lo};
+                const int width = static_cast<int>(src.width());
                 AstSel* const nLhsp = new AstSel{dflp, lhsp->cloneTreePure(false), lsbp, width};
                 // Convert source
-                convertDriver(assignments, dflp, nLhsp, srcp);
+                convertDriver(dflp, nLhsp, &src);
                 // Delete Sel - was cloned
                 VL_DO_DANGLING(nLhsp->deleteTree(), nLhsp);
+                return false;
             });
             return;
         }
 
         if (DfgSpliceArray* const sArrayp = driverp->cast<DfgSpliceArray>()) {
-            UASSERT_OBJ(!sArrayp->defaultp(), flp, "Should not have a default assignment yet");
             // Partial assignment of array variable
-            sArrayp->forEachSourceEdge([&](const DfgEdge& edge, size_t i) {
-                DfgVertex* const driverp = edge.sourcep();
-                UASSERT_OBJ(driverp, sArrayp, "Should have removed undriven sources");
-                UASSERT_OBJ(driverp->size() == 1, driverp, "We only handle single elements");
+            sArrayp->foreachDriver([&](DfgVertex& src, uint32_t lo, FileLine* dflp) {
+                UASSERT_OBJ(src.size() == 1, &src, "We only handle single elements");
                 // Create ArraySel
-                FileLine* const dflp = sArrayp->driverFileLine(i);
-                AstConst* const idxp = new AstConst{dflp, sArrayp->driverLo(i)};
+                AstConst* const idxp = new AstConst{dflp, lo};
                 AstArraySel* const nLhsp = new AstArraySel{dflp, lhsp->cloneTreePure(false), idxp};
                 // Convert source
-                if (const DfgUnitArray* const uap = driverp->cast<DfgUnitArray>()) {
-                    convertDriver(assignments, dflp, nLhsp, uap->srcp());
+                if (const DfgUnitArray* const uap = src.cast<DfgUnitArray>()) {
+                    convertDriver(dflp, nLhsp, uap->srcp());
                 } else {
-                    convertDriver(assignments, dflp, nLhsp, driverp);
+                    convertDriver(dflp, nLhsp, &src);
                 }
                 // Delete ArraySel - was cloned
                 VL_DO_DANGLING(nLhsp->deleteTree(), nLhsp);
+                return false;
             });
             return;
         }
@@ -210,17 +209,14 @@ class DfgToAstVisitor final : DfgVisitor {
             AstConst* const idxp = new AstConst{flp, 0};
             AstArraySel* const nLhsp = new AstArraySel{flp, lhsp->cloneTreePure(false), idxp};
             // Convert source
-            convertDriver(assignments, flp, nLhsp, uap->srcp());
+            convertDriver(flp, nLhsp, uap->srcp());
             // Delete ArraySel - was cloned
             VL_DO_DANGLING(nLhsp->deleteTree(), nLhsp);
             return;
         }
 
         // Base case: assign vertex to current lhs
-        AstNodeExpr* const rhsp = convertDfgVertexToAstNodeExpr(driverp);
-        assignments.emplace_back(flp, lhsp->cloneTreePure(false), rhsp);
-        ++m_ctx.m_resultEquations;
-        return;
+        createAssignment(flp, lhsp->cloneTreePure(false), driverp);
     }
 
     // VISITORS
@@ -258,7 +254,7 @@ class DfgToAstVisitor final : DfgVisitor {
 #include "V3Dfg__gen_dfg_to_ast.h"
 
     // Constructor
-    explicit DfgToAstVisitor(DfgGraph& dfg, V3DfgDfgToAstContext& ctx)
+    DfgToAstVisitor(DfgGraph& dfg, V3DfgDfgToAstContext& ctx)
         : m_modp{dfg.modulep()}
         , m_ctx{ctx} {
         // Convert the graph back to combinational assignments
@@ -266,55 +262,42 @@ class DfgToAstVisitor final : DfgVisitor {
         // The graph must have been regularized, so we only need to render assignments
         for (DfgVertexVar& vtx : dfg.varVertices()) {
             // If there is no driver (this vertex is an input to the graph), then nothing to do.
-            if (!vtx.srcp()) continue;
+            if (!vtx.srcp()) {
+                UASSERT_OBJ(!vtx.defaultp(), &vtx, "Only default driver on variable");
+                continue;
+            }
 
             ++m_ctx.m_outputVariables;
 
             // Render variable assignments
             FileLine* const flp = vtx.driverFileLine() ? vtx.driverFileLine() : vtx.fileline();
             AstVarRef* const lhsp = new AstVarRef{flp, getNode(&vtx), VAccess::WRITE};
-            convertDriver(m_assignments, flp, lhsp, vtx.srcp());
-            // convetDriver always clones lhsp
-            VL_DO_DANGLING(lhsp->deleteTree(), lhsp);
 
-            if (m_defaults.empty()) {
-                // If there are no default assignments, render each driver as an AssignW
-                for (const Assignment& a : m_assignments) {
-                    AstAssignW* const assignp = new AstAssignW{a.m_flp, a.m_lhsp, a.m_rhsp};
-                    a.m_lhsp->foreach([&a](AstNode* nodep) { nodep->fileline(a.m_flp); });
-                    if VL_CONSTEXPR_CXX17 (T_Scoped) {
-                        // Add it to the scope holding the target variable
-                        getCombActive(vtx.varScopep()->scopep())->addStmtsp(assignp);
-                    } else {
-                        // Add it to the parent module of the DfgGraph
-                        m_modp->addStmtsp(assignp);
-                    }
-                }
+            VL_RESTORER(m_containerp);
+            if VL_CONSTEXPR_CXX17 (T_Scoped) {
+                // Add it to the scope holding the target variable
+                AstActive* const activep = getCombActive(vtx.varScopep()->scopep());
+                m_containerp = reinterpret_cast<Container*>(activep);
             } else {
+                // Add it to the parent module of the DfgGraph
+                m_containerp = reinterpret_cast<Container*>(m_modp);
+            }
+
+            // If there is a default value, render all drivers under an AstAlways
+            VL_RESTORER(m_alwaysp);
+            if (DfgVertex* const defaultp = vtx.defaultp()) {
                 ++m_ctx.m_outputVariablesWithDefault;
-                // If there are default assignments, render all drivers under an AstAlways
-                AstAlways* const alwaysp
-                    = new AstAlways{vtx.fileline(), VAlwaysKwd::ALWAYS_COMB, nullptr, nullptr};
-                if VL_CONSTEXPR_CXX17 (T_Scoped) {
-                    // Add it to the scope holding the target variable
-                    getCombActive(vtx.varScopep()->scopep())->addStmtsp(alwaysp);
-                } else {
-                    // Add it to the parent module of the DfgGraph
-                    m_modp->addStmtsp(alwaysp);
-                }
-                for (const Assignment& a : m_defaults) {
-                    AstAssign* const assignp = new AstAssign{a.m_flp, a.m_lhsp, a.m_rhsp};
-                    a.m_lhsp->foreach([&a](AstNode* nodep) { nodep->fileline(a.m_flp); });
-                    alwaysp->addStmtsp(assignp);
-                }
-                for (const Assignment& a : m_assignments) {
-                    AstAssign* const assignp = new AstAssign{a.m_flp, a.m_lhsp, a.m_rhsp};
-                    a.m_lhsp->foreach([&a](AstNode* nodep) { nodep->fileline(a.m_flp); });
-                    alwaysp->addStmtsp(assignp);
-                }
+                m_alwaysp = new AstAlways{vtx.fileline(), VAlwaysKwd::ALWAYS_COMB, nullptr};
+                m_containerp->addStmtsp(m_alwaysp);
+                // The default assignment needs to go first
+                createAssignment(vtx.fileline(), lhsp->cloneTreePure(false), defaultp);
             }
-            m_assignments.clear();
-            m_defaults.clear();
+
+            // Render the drivers
+            convertDriver(flp, lhsp, vtx.srcp());
+
+            // convetDriver always clones lhsp
+            VL_DO_DANGLING(lhsp->deleteTree(), lhsp);
         }
     }
 
diff --git a/src/V3DfgOptimizer.cpp b/src/V3DfgOptimizer.cpp
index 451a7884191..e435775b05e 100644
--- a/src/V3DfgOptimizer.cpp
+++ b/src/V3DfgOptimizer.cpp
@@ -324,7 +324,7 @@ class DataflowOptimize final {
 
         // Mark interfaces that might be referenced by a virtual interface
         if (v3Global.hasVirtIfaces()) {
-            netlistp->typeTablep()->foreach([](AstIfaceRefDType* nodep) {
+            netlistp->typeTablep()->foreach([](const AstIfaceRefDType* nodep) {
                 if (!nodep->isVirtual()) return;
                 nodep->ifaceViaCellp()->setHasVirtualRef();
             });
diff --git a/src/V3DfgPasses.cpp b/src/V3DfgPasses.cpp
index 005e6e66bbc..72f882ad325 100644
--- a/src/V3DfgPasses.cpp
+++ b/src/V3DfgPasses.cpp
@@ -84,8 +84,7 @@ void V3DfgPasses::inlineVars(DfgGraph& dfg) {
     for (DfgVertexVar& vtx : dfg.varVertices()) {
         if (DfgVarPacked* const varp = vtx.cast<DfgVarPacked>()) {
             if (varp->hasSinks() && varp->isDrivenFullyByDfg()) {
-                DfgVertex* const driverp = varp->srcp();
-                varp->forEachSinkEdge([=](DfgEdge& edge) { edge.relinkSource(driverp); });
+                varp->replaceWith(varp->srcp());
             }
         }
     }
@@ -148,16 +147,17 @@ void V3DfgPasses::removeUnused(DfgGraph& dfg) {
             if (varp->hasDfgRefs()) continue;
         }
         // Add sources of unused vertex to work list
-        vtxp->forEachSource([&](DfgVertex& src) {
+        vtxp->foreachSource([&](DfgVertex& src) {
             // We only remove actual operation vertices and synthesis temporaries in this loop
-            if (src.is<DfgConst>()) return;
+            if (src.is<DfgConst>()) return false;
             const DfgVertexVar* const varp = src.cast<DfgVertexVar>();
-            if (varp && !varp->tmpForp()) return;
+            if (varp && !varp->tmpForp()) return false;
             // If already in work list then nothing to do
-            if (src.getUser<DfgVertex*>()) return;
+            if (src.getUser<DfgVertex*>()) return false;
             // Actually add to work list.
             src.setUser<DfgVertex*>(workListp);
             workListp = &src;
+            return false;
         });
         // Remove the unused vertex
         vtxp->unlinkDelete(dfg);
@@ -214,10 +214,13 @@ void V3DfgPasses::binToOneHot(DfgGraph& dfg, V3DfgBinToOneHotContext& ctx) {
         if (DfgVertex* const sinkp = vtxp->singleSink()) {
             if (sinkp->is<DfgNot>()) return useOk(sinkp, !inv);
         }
-        return !vtxp->findSink<DfgCond>([vtxp, inv](const DfgCond& sink) {
-            if (sink.condp() != vtxp) return false;
-            return inv ? sink.thenp()->is<DfgCond>() : sink.elsep()->is<DfgCond>();
+        const bool condTree = vtxp->foreachSink([&](const DfgVertex& sink) {
+            const DfgCond* const condp = sink.cast<DfgCond>();
+            if (!condp) return false;
+            if (condp->condp() != vtxp) return false;
+            return inv ? condp->thenp()->is<DfgCond>() : condp->elsep()->is<DfgCond>();
         });
+        return !condTree;
     };
 
     // Look at all comparison nodes and build the 'Val2Terms' map for each source vertex
@@ -306,7 +309,7 @@ void V3DfgPasses::binToOneHot(DfgGraph& dfg, V3DfgBinToOneHotContext& ctx) {
 
         // Required data types
         AstNodeDType* const idxDTypep = srcp->dtypep();
-        AstNodeDType* const bitDTypep = DfgGraph::dtypePacked(1);
+        AstNodeDType* const bitDTypep = V3Dfg::dtypePacked(1);
         AstUnpackArrayDType* const tabDTypep = new AstUnpackArrayDType{
             flp, bitDTypep, new AstRange{flp, static_cast<int>(nBits - 1), 0}};
         v3Global.rootp()->typeTablep()->addTypesp(tabDTypep);
@@ -438,10 +441,11 @@ void V3DfgPasses::eliminateVars(DfgGraph& dfg, V3DfgEliminateVarsContext& ctx) {
     const auto addToWorkList = [&](DfgVertex& vtx) {
         // If already in work list then nothing to do
         DfgVertex*& nextInWorklistp = vtx.user<DfgVertex*>();
-        if (nextInWorklistp) return;
+        if (nextInWorklistp) return false;
         // Actually add to work list.
         nextInWorklistp = workListp;
         workListp = &vtx;
+        return false;
     };
 
     // List of variables (AstVar or AstVarScope) we are replacing
@@ -467,7 +471,7 @@ void V3DfgPasses::eliminateVars(DfgGraph& dfg, V3DfgEliminateVarsContext& ctx) {
         // Remove unused non-variable vertices
         if (!vtxp->is<DfgVertexVar>() && !vtxp->hasSinks()) {
             // Add sources of removed vertex to work list
-            vtxp->forEachSource(addToWorkList);
+            vtxp->foreachSource(addToWorkList);
             // Remove the unused vertex
             vtxp->unlinkDelete(dfg);
             continue;
@@ -517,7 +521,7 @@ void V3DfgPasses::eliminateVars(DfgGraph& dfg, V3DfgEliminateVarsContext& ctx) {
         }
 
         // Add sources of redundant variable to the work list
-        vtxp->forEachSource(addToWorkList);
+        vtxp->foreachSource(addToWorkList);
         // Remove the redundant variable
         vtxp->unlinkDelete(dfg);
     }
diff --git a/src/V3DfgPatternStats.h b/src/V3DfgPatternStats.h
index d9597d00b70..666c5bcb682 100644
--- a/src/V3DfgPatternStats.h
+++ b/src/V3DfgPatternStats.h
@@ -118,9 +118,10 @@ class V3DfgPatternStats final {
             }
 
             // Operands
-            vtx.forEachSource([&](const DfgVertex& src) {
+            vtx.foreachSource([&](const DfgVertex& src) {
                 ss << ' ';
                 if (render(ss, src, depth - 1)) deep = true;
+                return false;
             });
             // S-expression end
             ss << ')';
